name: Frontend CI/CD

on:
  push:
    branches: [production]
    paths:
      - '**'
      - '.gitea/workflows/frontend.yml'

pull_request:
    branches: [production]
    paths:
      - '**'
      - '.gitea/workflows/frontend.yml'

jobs:
  build-and-test:
    name: Build, Lint & Test
    runs-on: self-hosted
    container:
      image: mirror2.chabokan.net/ubuntu:22.04
      options: --add-host gitea:172.17.0.1

    steps:
      - name: Setup Ubuntu apt mirrors
        run: |
          tee /etc/apt/sources.list > /dev/null <<'EOF'
          deb https://mirror-linux.runflare.com/ubuntu/ noble main restricted universe multiverse
          deb https://mirror-linux.runflare.com/ubuntu/ noble-updates main restricted universe multiverse
          deb https://mirror-linux.runflare.com/ubuntu/ noble-backports main restricted universe multiverse
          deb https://mirror-linux.runflare.com/ubuntu/ noble-security main restricted universe multiverse

          deb [trusted=yes] https://mirror2.chabokan.net/ubuntu focal main universe
          deb [trusted=yes] https://mirror2.chabokan.net/ubuntu focal-updates main universe
          deb [trusted=yes] https://mirror2.chabokan.net/ubuntu focal-security main universe




          deb http://mirror.iranserver.com/ubuntu/ jammy main restricted
          deb-src http://mirror.iranserver.com/ubuntu/ jammy main restricted


          deb http://mirror.iranserver.com/ubuntu/ jammy-updates main restricted
          deb-src http://mirror.iranserver.com/ubuntu/ jammy-updates main restricted


          deb http://mirror.iranserver.com/ubuntu/ jammy universe
          deb-src http://mirror.iranserver.com/ubuntu/ jammy universe
          deb http://mirror.iranserver.com/ubuntu/ jammy-updates universe


 
          deb http://mirror.iranserver.com/ubuntu/ jammy multiverse
          deb-src http://mirror.iranserver.com/ubuntu/ jammy multiverse
          deb http://mirror.iranserver.com/ubuntu/ jammy-updates multiverse
          deb-src http://mirror.iranserver.com/ubuntu/ jammy-updates multiverse


          deb http://mirror.iranserver.com/ubuntu/ jammy-backports main restricted universe multiverse
          deb-src http://mirror.iranserver.com/ubuntu/ jammy-backports main restricted universe multiverse

      
          EOF
          apt-get update
      - name: Install dependencies
        run: |
          apt-get install -y openssh-client git
   
      - name: Setup SSH key
        run: |
          mkdir -p ~/.ssh
          echo "${{ secrets.SSH_PRIVATE_KEY }}" > ~/.ssh/id_ed25519
          chmod 600 ~/.ssh/id_ed25519
          ssh-keyscan -p ${{ secrets.SERVER_SSH_PORT }} -H ${{ secrets.SERVER_HOST }} >> ~/.ssh/known_hosts

      - name: Deploy
        run: |
          ssh ${{ secrets.SERVER_USER }}@${{ secrets.SERVER_HOST }} -p ${{ secrets.SERVER_SSH_PORT }} << 'EOF'
          cd application/Frontend
          git pull origin production
          docker-compose -f docker-compose-prod.yml down  --remove-orphans 
          docker-compose -f docker-compose-prod.yml up -d --build
          EOF
